
<div class='main'>
  <div id='tests'>
  </div>
  <div id='term_wrap'>
    <div id='term_container'>
    </div>
  </div>
</div>

<script type='text/javascript'>

  /*
   * Test of the Exec API
   */

  var execTests = [
    {
      name: 'ls',
      run: () => {
        return new Promise(async (resolve, reject) => {
          const cmd = String.raw`ls /`;
          try {
            const {exitCode, outputShell} =
              await LupBookVM.Exec.run(cmd, {outPath: "/dev/console"});
            const txt = `${cmd}\n`
              + `${exitCode}\n`
              + `${outputShell}\n`;
            resolve({
              pass: exitCode === 0,
              log: txt,
            });
          } catch (err) {
            reject(err);
          }
        });
      }
    },
    {
      name: 'Hello world',
      run: () => {
        return new Promise(async (resolve, reject) => {
          const cmd = String.raw`echo -en "Hello world!\n"`;
          try {
            const {exitCode, outputShell} =
              await LupBookVM.Exec.run(cmd, {outPath: "/dev/console"});
            const txt = `${cmd}\n`
              + `${exitCode}\n`
              + `${outputShell}\n`;
            resolve({
              pass: exitCode === 0 && outputShell.endsWith("Hello world!\n"),
              log: txt,
            });
          } catch (err) {
            reject(err);
          }
        });
      }
    },
  ];

  function runTests() {
    /* Create spaceholders for each test */
    const testDiv = document.getElementById('tests');
    execTests.forEach((t) => {
      t.elem = document.createElement('div');
      t.elem.className = 'test_well';
      const title = document.createElement('h2');
      title.textContent = t.name;
      t.elem.appendChild(title);
      testDiv.appendChild(t.elem);
    });

    /* Run each test */
    execTests.forEach((t) => {
      const showTestResult = (pass, log) => {
        const result = document.createElement('h3');
        result.className = pass ? 'test_pass' : 'test_fail';
        result.textContent = pass ? 'Pass' : 'Fail';

        const output = document.createElement('pre');
        output.textContent = log;

        t.elem.appendChild(result);
        t.elem.appendChild(output);
      }

      t.run()
        .then(({pass, log}) => showTestResult(pass, log))
        .catch((err) => showTestResult(false, err));
    });
  };

  const termGeometry = {width: 80, height: 24};
  const term = new Term({
    cols: termGeometry.width, rows: termGeometry.height,
    scrollback: 10000, fontSize: 12 });

  function termHandler(str) {
    for (const c of str)
      LupBookVM.Core.consoleQueue(c.charCodeAt(0));
  };

  window.onload = (e) => {
    term.open(document.getElementById('term_container'));

    term.write("Loading VM...\r\n");
    term.setKeyHandler(termHandler);

    LupBookVM.Client.boot({
      consoleWriteDebug: (str) => term.write(str),
      consoleGeometryDebug: () => {
        const [w, h] = term.getSize();
        return { width : w, height : h};
      }
    })
      .then(() => {
        console.log('VM Init complete!');
        return LupBookVM.Exec.init();
      })
      .then(() => {
        runTests();
      })
      .catch((err) => console.log('VM Error: ' + err))
  };
</script>
